質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

新規登録して質問してみよう
ただいま回答率
85.46%
Python 3.x

Python 3はPythonプログラミング言語の最新バージョンであり、2008年12月3日にリリースされました。

Q&A

解決済

2回答

15003閲覧

PythonのPandasで値の代入のエラー

gymgym

総合スコア97

Python 3.x

Python 3はPythonプログラミング言語の最新バージョンであり、2008年12月3日にリリースされました。

0グッド

0クリップ

投稿2018/01/22 16:18

Python

1def main(): 2 features_df = pd.DataFrame() 3 features_df['labels'] = [0,1,2,0,1] 4 features_df['T1'][0] = 1 5 features_df['T2'][0] = 1 6 print(features_df) 7 8if __name__ == '__main__': 9 main()
想定している結果 labels T1 T2 0 0 1 1 1 1 Nan Nan 2 2 Nan Nan 3 0 Nan Nan 4 1 Nan Nan

以上のコードを実行すると、

Traceback (most recent call last): File "/Users/anaconda/lib/python3.6/site-packages/pandas/core/indexes/base.py", line 2393, in get_loc return self._engine.get_loc(key) File "pandas/_libs/index.pyx", line 132, in pandas._libs.index.IndexEngine.get_loc (pandas/_libs/index.c:5239) File "pandas/_libs/index.pyx", line 154, in pandas._libs.index.IndexEngine.get_loc (pandas/_libs/index.c:5085) File "pandas/_libs/hashtable_class_helper.pxi", line 1207, in pandas._libs.hashtable.PyObjectHashTable.get_item (pandas/_libs/hashtable.c:20405) File "pandas/_libs/hashtable_class_helper.pxi", line 1215, in pandas._libs.hashtable.PyObjectHashTable.get_item (pandas/_libs/hashtable.c:20359) KeyError: 'T1' During handling of the above exception, another exception occurred: Traceback (most recent call last): File "pa.py", line 94, in <module> main() File "pa.py", line 89, in main features_df['T1'][1] = 1 File "/Users/anaconda/lib/python3.6/site-packages/pandas/core/frame.py", line 2062, in __getitem__ return self._getitem_column(key) File "/Users/anaconda/lib/python3.6/site-packages/pandas/core/frame.py", line 2069, in _getitem_column return self._get_item_cache(key) File "/Users/anaconda/lib/python3.6/site-packages/pandas/core/generic.py", line 1534, in _get_item_cache values = self._data.get(item) File "/Users/anaconda/lib/python3.6/site-packages/pandas/core/internals.py", line 3590, in get loc = self.items.get_loc(item) File "/Users/anaconda/lib/python3.6/site-packages/pandas/core/indexes/base.py", line 2395, in get_loc return self._engine.get_loc(self._maybe_cast_indexer(key)) File "pandas/_libs/index.pyx", line 132, in pandas._libs.index.IndexEngine.get_loc (pandas/_libs/index.c:5239) File "pandas/_libs/index.pyx", line 154, in pandas._libs.index.IndexEngine.get_loc (pandas/_libs/index.c:5085) File "pandas/_libs/hashtable_class_helper.pxi", line 1207, in pandas._libs.hashtable.PyObjectHashTable.get_item (pandas/_libs/hashtable.c:20405) File "pandas/_libs/hashtable_class_helper.pxi", line 1215, in pandas._libs.hashtable.PyObjectHashTable.get_item (pandas/_libs/hashtable.c:20359) KeyError: 'T1'

このようなエラーがでてしまいます。
原因はなにが考えられるでしょうか。

よろしくお願い致します。

気になる質問をクリップする

クリップした質問は、後からいつでもMYページで確認できます。

またクリップした質問に回答があった際、通知やメールを受け取ることができます。

バッドをするには、ログインかつ

こちらの条件を満たす必要があります。

guest

回答2

0

ベストアンサー

loc[]をお使いください

Python

1import pandas as pd 2 3features_df = pd.DataFrame() 4features_df['labels'] = [0,1,2,0,1] 5features_df.loc[0, 'T1'] = 1 6features_df.loc[0, 'T2'] = 1 7print(features_df) 8# labels T1 T2 9#0 0 1.0 1.0 10#1 1 NaN NaN 11#2 2 NaN NaN 12#3 0 NaN NaN 13#4 1 NaN NaN

投稿2018/01/22 23:21

magichan

総合スコア15898

バッドをするには、ログインかつ

こちらの条件を満たす必要があります。

gymgym

2018/01/23 04:13

回答ありがとうございます。 参考にさせていただきます。
guest

0

python

1import pandas as pd 2 3d = {"labels": [0,1,2,0,1], "T1": None, "T2":None} 4df = pd.DataFrame(d) 5df["T1"][0] = 1 6df["T2"][0] = 1 7""" 8 T1 T2 labels 90 1 1 0 101 None None 1 112 None None 2 123 None None 0 134 None None 1 14"""

投稿2018/01/22 22:08

wakame

総合スコア1170

バッドをするには、ログインかつ

こちらの条件を満たす必要があります。

gymgym

2018/01/23 04:12

回答ありがとうございます。 参考にさせていただきます。
guest

あなたの回答

tips

太字

斜体

打ち消し線

見出し

引用テキストの挿入

コードの挿入

リンクの挿入

リストの挿入

番号リストの挿入

表の挿入

水平線の挿入

プレビュー

15分調べてもわからないことは
teratailで質問しよう!

ただいまの回答率
85.46%

質問をまとめることで
思考を整理して素早く解決

テンプレート機能で
簡単に質問をまとめる

質問する

関連した質問